# ExponentialAction

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://sethaxen.github.io/ExponentialAction.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://sethaxen.github.io/ExponentialAction.jl/dev)
[![Build Status](https://github.com/sethaxen/ExponentialAction.jl/actions/workflows/CI.yml/badge.svg?branch=main)](https://github.com/sethaxen/ExponentialAction.jl/actions/workflows/CI.yml?query=branch%3Amain)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)
[![Coverage](https://codecov.io/gh/sethaxen/ExponentialAction.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/sethaxen/ExponentialAction.jl)
[![Code Style: Blue](https://img.shields.io/badge/code%20style-blue-4495d1.svg)](https://github.com/invenia/BlueStyle)
[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)

ExponentialAction is a lightweight package that implements the action of the [Matrix exponential](https://en.wikipedia.org/wiki/Matrix_exponential) using the algorithm of Al-Mohy and Higham [^AlMohyHigham2011][^Expmv].

[^AlMohyHigham2011]: Al-Mohy, Awad H. and Higham, Nicholas J. (2011) Computing the Action of the Matrix Exponential, with an Application to Exponential Integrators.
    SIAM Journal on Scientific Computing, 33 (2). pp. 488-511. ISSN 1064-8275
    doi: [10.1137/100788860](https://doi.org/10.1137/100788860),
    eprint: [eprints.maths.manchester.ac.uk/id/eprint/1591](http://eprints.maths.manchester.ac.uk/id/eprint/1591)
[^Expmv]: https://github.com/higham/expmv

The API of this package is a single function `expv(t, A, B)` that computes `exp(t * A) * B` for a scalar `t`, matrix `A`, and matrix or vector `B`, without computing `exp(t * A)`.
For large matrices `A`, this is significantly less expensive than calling `exp(t * A) * B` directly.

See the [Documentation](https://sethaxen.github.io/ExponentialAction.jl/stable) for details.

using ExponentialAction, Test

@testset "expv_taylor" begin
    for i in 1:0.1:10
        t = rand() * i
        A = randn(5, 5)
        A /= opnorm(A, 1)
        B = randn(5, 2)
        @test ExponentialAction.expv_taylor(t, A, B, 1_000) ≈ exp(t * A) * B
    end
end

using ExponentialAction, LinearAlgebra, SparseArrays, Test

Tsingle = (Float32, ComplexF32)
Tdouble = (Float64, ComplexF64)

@testset "expv" begin
    n = 10
    @testset "expv(t::$Tt, A::$MT{$TA}, B::Array{$TB,$(length(Bdims2)+1)}), tscale=$tscale, shift=$shift" for MT in
                                                                                                              (
            Matrix, Diagonal, Bidiagonal, Tridiagonal
        ),
        Tset in (Tsingle, Tdouble),
        Bdims2 in ((), (4,)),
        Tt in Tset,
        TA in Tset,
        TB in Tset,
        tscale in Tt.((0.1, 1, 10)),
        shift in (true, false)

        t = tscale * randn(Tt)
        if MT <: Bidiagonal
            A = MT(randn(TA, n, n), :U)
        else
            A = MT(randn(TA, n, n))
        end
        B = randn(TB, n, Bdims2...)
        T = Base.promote_eltype(t, A, B)
        rT = real(T)
        @inferred expv(t, A, B; shift)
        @test expv(t, A, B; shift) ≈ exp(Matrix(t * A)) * B
        @test eltype(expv(t, A, B; shift)) === T
    end

    @testset "expv(t::$Tt, A::SparseMatrixCSC{$TA}, B::Array{$TB,$(length(Bdims2)+1)}), tscale=$tscale, shift=$shift" for Tset in
                                                                                                                          (
            Tsingle, Tdouble
        ),
        Bdims2 in ((), (4,)),
        Tt in Tset,
        TA in Tset,
        TB in Tset,
        tscale in Tt.((0.1, 1, 10)),
        shift in (true, false)

        t = tscale * randn(Tt)
        A = sprandn(TA, n, n, 1 / n)
        B = randn(TB, n, Bdims2...)
        T = Base.promote_eltype(t, A, B)
        rT = real(T)
        @inferred expv(t, A, B; shift)
        @test expv(t, A, B; shift) ≈ exp(Matrix(t * A)) * B
        @test eltype(expv(t, A, B; shift)) === T
    end

    @testset "errors if tolerance too low" begin
        t = randn()
        A = randn(10, 10)
        B = randn(10, 10)

        @test_throws DomainError expv(t, A, B; tol=eps(Float64) / 100)
        @test_throws DomainError expv(big(t), big.(A), big.(B))
    end

    @testset "tA=0" begin
        t = rand()
        A = randn(5, 5)
        B = randn(5, 2)
        @test expv(zero(t), A, B) ≈ B
        @test expv(t, zero(A), B) ≈ B
    end

    @testset "no errors for high norm" begin
        # https://github.com/sethaxen/ExponentialAction.jl/issues/10
        t = 20.0

        #! format: off
        A = [-4.19   0.0     8.75   0.0   0.0
              0.0  -57.45   33.26   0.0   0.0
              0.0    0.0  -175.05   0.0   0.0
              4.19  57.45    0.0  -87.53  6.28
              0.0    0.0    13.13   0.0  -6.28]
        #! format: on

        B = ones(size(A, 2))
        @test expv(t, A, B) ≈ exp(t * A) * B
    end
end

"""
    expv_sequence(t::AbstractVector, A, B; kwargs...)

Compute ``\\exp(t_i A)B`` for the (sorted) sequence of (real) time points ``t=(t_1, t_2, \\ldots)``.

At each time point, the result ``F_i`` is computed as
```math
F_i = \\exp\\left((t_i - t_{i-1}) A\\right) F_{i - 1}
```
using [`expv`](@ref), where ``t_0 = 0`` and ``F_0 = B``.
For details, see Equation 5.2 of [^AlMohyHigham2011].

Because the cost of computing `expv` is related to the operator 1-norm of ``t_i A``, this
incremental computation is more efficient than computing `expv` separately for each time
point.

See [`expv`](@ref) for a description of acceptable `kwargs`.

    expv_sequence(t::AbstractRange, A, B; kwargs...)

Compute [`expv`](@ref) over the uniformly spaced sequence.

This algorithm takes special care to avoid overscaling and to save and reuse matrix products
and is described in Algorithm 5.2 of [^AlMohyHigham2011].
"""
function expv_sequence(ts, A, B; shift=true, tol=default_tol(ts, A, B))
    A, μ = shift ? shift_matrix(A) : (A, zero(float(eltype(A))))
    t = t_old = ts[begin]
    F = expv(t, A, B; shift, tol) * exp(μ * t)
    Fs = [F]
    for t in ts[(begin + 1):end]
        Δt = t - t_old
        F = expv(Δt, A, F; shift=false, tol) * exp(μ * Δt)
        Fs = vcat(Fs, [F])  # avoid mutation
        t_old = t
    end
    return Fs
end
function expv_sequence(ts::AbstractRange, A, B; shift=true, tol=default_tol(ts, A, B))
    ncols_B = size(B, 2)
    num_steps = length(ts) - 1  # q
    t_min = ts[begin]
    t_max = ts[end]
    t_span = t_max - t_min
    Δt = (t_max - t_min) / num_steps

    A, μ = shift ? shift_matrix(A) : (A, zero(float(eltype(A))))

    degree_opt, scale = parameters(t_span, A, ncols_B; tol)  # (m*, s)

    F = expv(t_min, A, B; shift=false, tol) * exp(μ * t_min)

    if num_steps == 0
        return [F]
    elseif num_steps ≤ scale
        # points are intermediate matrices of a scaling sequence
        _, Fs_tail = _expv_sequence_core(Δt, A, F, degree_opt, μ, num_steps, tol)
        return vcat([F], Fs_tail)
    else
        num_steps_per_scale = fld(num_steps, scale)  # d
        scale_actual, num_steps_last = fldmod(num_steps, num_steps_per_scale)  # (j, r)
        Fs = [F]
        for i in 1:(scale_actual + 1)
            # for each scaling step, points are intermediate matrices
            # get number of steps to take in this scale
            d = i ≤ scale_actual ? num_steps_per_scale : num_steps_last
            d == 0 && continue
            F, Fs_tail = _expv_sequence_core_cache(Δt, A, F, degree_opt, μ, d, tol)
            Fs = vcat(Fs, Fs_tail)
        end
        return Fs
    end
end

# like _expv_core, but returns the entire sequence of F matrices
function _expv_sequence_core(Δt, A, B, degree_opt, μ, num_steps, tol)
    η = exp(Δt * μ)
    F = expv_taylor(Δt, A, B, degree_opt; tol) * η
    Fs = [F]
    for _ in 2:num_steps
        F = expv_taylor(Δt, A, F, degree_opt; tol) * η  # new starting matrix
        Fs = vcat(Fs, [F])  # avoid mutation
    end
    return F, Fs
end

# like _expv_sequence_core, but all steps are relative to B, so we can cache matrix products
function _expv_sequence_core_cache(Δt, A, B, degree_opt, μ, num_steps, tol)
    F1, Zs = expv_taylor_cache(Δt, A, B, degree_opt, 1, [B]; tol)
    F = F1 *= exp(μ * Δt)
    Fs = [F1]
    for k in 2:num_steps
        F, Zs = expv_taylor_cache(Δt, A, B, degree_opt, k, Zs; tol)
        F *= exp(μ * k * Δt)
        Fs = vcat(Fs, [F])  # avoid mutation
    end
    return F, Fs
end

"""
    expv_taylor(t, A, B, degree_max; tol)

Compute ``\\exp(tA)B`` using the truncated Taylor series with degree ``m=`` `degree_max`.

Instead of computing the Taylor series ``T_m(tA)`` of the matrix exponential directly, its
action on ``B`` is computed instead.

The series is truncated early if

```math
\\frac{\\lVert \\exp(t A) B - T_m(tA) B \\rVert_1}{\\lVert T_m(tA) B \\rVert_1} \\le \\mathrm{tol},
```

where ``\\lVert X \\rVert_1`` is the operator 1-norm of the matrix ``X``.
This condition is only approximately checked.
"""
function expv_taylor(t, A, B, degree_max; tol=default_tol(t, A, B))
    F = Z = B
    norm_tail_old = _opnormInf(Z)
    for j in 1:degree_max
        Z = (A * Z) * (t / j)  # (t A)ʲ/j! * B
        F += Z
        # check if ratio of norm of tail and norm of series is below tolerance
        norm_tail = _opnormInf(Z)
        norm_tail_tot = norm_tail_old + norm_tail
        norm_tail_tot ≤ tol * _opnormInf(F) && break
        norm_tail_old = norm_tail
    end
    return F
end

"""
    expv_taylor_cache(t, A, B, degree_max, k, Z; tol)

Compute ``\\exp(tkA)B`` using the truncated Taylor series with degree ``m=`` `degree_max`.

This method stores all matrix products in a cache `Z`, where
``Z_p = \\frac{1}{(p-1)!} (t A)^{p-1} B``.
This cache can be reused if ``k`` changes but ``t``, ``A``, and ``B`` are unchanged.

`Z` is a vector of arrays of the same shape as `B` and is not mutated; instead the
(possibly updated) cache is returned.

# Returns

  - `F::AbstractMatrix`: The action of the truncated Taylor series
  - `Z::AbstractVector`: The cache of matrix products of the same shape as `F`. If the cache
    is updated, then this is a different object than the input `Z`.

See [`expv_taylor`](@ref).
"""
function expv_taylor_cache(t, A, B, degree_max, k, Zs; tol=default_tol(t, A, B))
    F = Z = B
    norm_tail_old = _opnormInf(Z)
    kʲ = float(one(k))
    cache_size = length(Zs)
    for j in 1:degree_max
        kʲ *= k
        if cache_size < j + 1
            Z = (A * Z) * (t / j)  # (t A)ʲ/j! * B
            Zs = vcat(Zs, [Z])
        else
            Z = Zs[j + 1]
        end
        F = muladd(kʲ, Z, F)
        # check if ratio of norm of tail and norm of series is below tolerance
        norm_tail = kʲ * _opnormInf(Z)
        norm_tail_tot = norm_tail_old + norm_tail
        norm_tail_tot ≤ tol * _opnormInf(F) && break
        norm_tail_old = norm_tail
    end
    return F, Zs
end

"""
`ExponentialAction.jl` implements the action of the [Matrix exponential](https://en.wikipedia.org/wiki/Matrix_exponential).

For details, see the docstring of [`expv`](@ref).

# Exports

- [`expv`](@ref): compute the action of the matrix exponential
"""
module ExponentialAction

using LinearAlgebra
using ChainRulesCore: ChainRulesCore
using SparseArrays: sparse
using AbstractDifferentiation: AbstractDifferentiation as AD

include("util.jl")
include("coefficients.jl")
include("parameters.jl")
include("taylor.jl")
include("expv.jl")
include("sequence.jl")

export expv, expv_sequence

end

using ExponentialAction
using Random
using Test

Random.seed!(1)  # set seed used for all testsets

@testset "ExponentialAction.jl" begin
    include("aqua.jl")
    include("helpers.jl")
    include("util.jl")
    include("taylor.jl")
    include("expv.jl")
    include("sequence.jl")
    include("autodiff.jl")
end

# workaround for opnorm(::AbstractVector, Inf) not being implemented
_opnormInf(B) = opnorm(AD.primal_value(B), Inf)
_opnormInf(B::AbstractVector) = norm(AD.primal_value(B), Inf)

# TODO: replace with estimate
# see https://github.com/JuliaLang/julia/pull/39058
opnormest1(A) = opnorm(A, 1)

asint(x) = x ≤ typemax(Int) ? Int(x) : typemax(Int)

default_tol(args...) = AD.primal_value(eps(float(real(Base.promote_eltype(args...)))))

function shift_matrix(A)
    μ = get_shift(A)
    return (A - μ * I), μ
end

get_shift(A) = AD.primal_value(tr(A)) / LinearAlgebra.checksquare(A)

# we only use these for control flow, so avoid differentiating through them
ChainRulesCore.@non_differentiable _opnormInf(B)
ChainRulesCore.@non_differentiable default_tol(args...)
ChainRulesCore.@non_differentiable get_shift(A)

using ExponentialAction, ChainRulesCore, ChainRulesTestUtils, LinearAlgebra, Test
using ExponentialAction: _opnormInf

@testset "Utilities" begin
    @testset "_opnormInf" begin
        A = randn(ComplexF64, 10)
        @test _opnormInf(A) ≈ _opnormInf(reshape(A, 10, 1))
        @test _opnormInf(A) ≈ norm(A, Inf)
        A = randn(ComplexF64, 10, 10)
        @test _opnormInf(A) ≈ opnorm(A, Inf)
    end

    @testset "_opnormInf non-differentiable" begin
        test_rrule(_opnormInf, randn(ComplexF64, 10) ⊢ NoTangent(); atol=1e-6)
        test_rrule(_opnormInf, randn(ComplexF64, 10, 10) ⊢ NoTangent(); atol=1e-6)
    end

    @testset "opnormest1" begin
        A = randn(ComplexF64, 10, 10)
        @test ExponentialAction.opnormest1(A) ≈ opnorm(A, 1)
    end

    @testset "asint" begin
        @test ExponentialAction.asint(float(typemax(Int))) == typemax(Int)
        @test ExponentialAction.asint(37.0) == 37
    end

    @testset "default_tol" begin
        @test ExponentialAction.default_tol(randn()) ≈ eps(Float64)
        @test ExponentialAction.default_tol(randn(ComplexF64)) ≈ eps(Float64)
        @test ExponentialAction.default_tol(randn(Float32)) ≈ eps(Float32)
        @test ExponentialAction.default_tol(1, randn()) ≈ eps(Float64)
        test_rrule(ExponentialAction.default_tol, randn() ⊢ NoTangent(); atol=1e-6)
    end
end

using ExponentialAction
using Documenter

DocMeta.setdocmeta!(ExponentialAction, :DocTestSetup, :(using ExponentialAction); recursive=true)

makedocs(;
    modules=[ExponentialAction],
    authors="Seth Axen <seth.axen@gmail.com> and contributors",
    repo="https://github.com/sethaxen/ExponentialAction.jl/blob/{commit}{path}#{line}",
    sitename="ExponentialAction.jl",
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        canonical="https://sethaxen.github.io/ExponentialAction.jl",
        assets=String[],
    ),
    pages=[
        "Home" => "index.md",
        "Library" => [
            "Public" => "lib/public.md",
            "Internals" => "lib/internals.md",
        ]
    ],
)

deploydocs(;
    repo="github.com/sethaxen/ExponentialAction.jl",
    devbranch="main",
)

"""
    expv(t, A, B; shift=true, tol)

Compute ``\\exp(tA)B`` without computing ``tA`` or the matrix exponential  ``\\exp(tA)``.

Computing the action of the matrix exponential is significantly faster than computing
the matrix exponential and then multiplying it when the second dimension of ``B`` is
much smaller than the first one. The "time" ``t`` may be real or complex.

In short, the approach computes
```math
F = T_m(tA / s)^s B,
```
where ``T_m(X)`` is the Taylor series of ``\\exp(X)`` truncated to degree ``m = m^*``.
The term ``s`` determines how many times the Taylor series acts on ``B``.
``m^*`` and ``s`` are chosen to minimize the number of matrix products needed while
maintaining the required tolerance `tol`.

The algorithm is described in detail in Algorithm 3.2 in [^AlMohyHigham2011].

[^AlMohyHigham2011]: Al-Mohy, Awad H. and Higham, Nicholas J. (2011)
    Computing the Action of the Matrix
    Exponential, with an Application to Exponential Integrators. SIAM Journal on Scientific
    Computing, 33 (2). pp. 488-511. ISSN 1064-8275
    doi: [10.1137/100788860](https://doi.org/10.1137/100788860)
    eprint: [eprints.maths.manchester.ac.uk/id/eprint/1591](http://eprints.maths.manchester.ac.uk/id/eprint/1591)
# Keywords

  - `shift=true`: Expand the Taylor series about the ``n \\times n`` matrix ``A-μI=0``
    instead of ``A=0``, where ``μ = \\operatorname{tr}(A) / n`` to speed up convergence. See
    §3.1 of [^AlMohyHigham2011].
  - `tol`: The relative tolerance at which to compute the result. Defaults to the tolerance
    of the eltype of the result.
"""
function expv(t, A, B; shift=true, tol=default_tol(t, A, B))
    A, μ = shift ? shift_matrix(A) : (A, zero(float(eltype(A))))
    degree_opt, scale = parameters(t, A, size(B, 2); tol)  # m*, s
    F = _expv_core(t * one(μ) / scale, A, B, degree_opt, μ, scale, tol)
    return F
end
expv(t, A::Diagonal, B; kwargs...) = exp.(t .* A.diag) .* B

function _expv_core(Δt, A, B, degree_opt, μ, num_steps, tol)
    η = exp(Δt * μ)
    F = one(η) * B
    for _ in 1:num_steps
        F = expv_taylor(Δt, A, F, degree_opt; tol) * η  # new starting matrix
    end
    return F
end

"""
    parameters(t, A, ncols_B; kwargs...) -> (degree_opt, scale)

Compute Taylor series parameters needed for ``\\exp(tA)B``.

This is Code Fragment 3.1 from [^AlMohyHigham2011].

[^AlMohyHigham2011]: Al-Mohy, Awad H. and Higham, Nicholas J. (2011)
    Computing the Action of the Matrix
    Exponential, with an Application to Exponential Integrators. SIAM Journal on Scientific
    Computing, 33 (2). pp. 488-511. ISSN 1064-8275
    doi: [10.1137/100788860](https://doi.org/10.1137/100788860)
    eprint: [eprints.maths.manchester.ac.uk/id/eprint/1591](http://eprints.maths.manchester.ac.uk/id/eprint/1591)
# Keywords

  - `tol`: the desired relative tolerance
  - `degree_max=55`: the maximum degree of the truncated Taylor series that will be used.
    This is ``m_{\\mathrm{max}}`` in [^AlMohyHigham2011], where they recommend a value of 55
    in §3.
  - `ℓ=2`: the number of columns in the matrix that is multiplied for norm estimation (note:
    currently only used for control flow.). Recommended values are 1 or 2.

# Returns

  - `degree_opt`: the degree of the truncated Taylor series that will be used. This is
    ``m^*`` in [^AlMohyHigham2011],
  - `scale`: the amount of scaling ``s`` that will be applied to ``A``. The truncated Taylor
    series of ``\\exp(t A / s)`` will be applied ``s`` times to ``B``.
"""
function parameters(t, A, ncols_B; tol=default_tol(t, A), degree_max::Int=55, ℓ::Int=2)
    return _parameters(AD.primal_value(t), AD.primal_value(A), ncols_B, degree_max, ℓ, tol)
end

function _parameters(t, A, ncols_B, degree_max, ℓ, tol)
    t_norm = abs(t)
    iszero(t_norm) && return (0, 1)
    Anorm = opnormest1(A)
    iszero(Anorm) && return (0, 1)
    tA_norm = t_norm * Anorm
    T = float(real(Base.promote_eltype(t, A)))
    θ = coefficients(T(tol))
    p_max = p_from_degree_max(degree_max)
    if _cost_case1(tA_norm, ncols_B, degree_max, θ[degree_max]) ≤ _cost_case2(ℓ, p_max)  # (3.13) is satisfied
        num_mat_muls = map(1:degree_max) do m
            return asint(m * cld(tA_norm, θ[m]))
        end
        degree_opt = argmin(num_mat_muls)
        num_mat_mul_opt = num_mat_muls[degree_opt]
        scale = cld(num_mat_mul_opt, degree_opt)
    else
        # TODO: replace powers of A here and below with opnormest(pow, A, 1)
        # see https://github.com/JuliaLang/julia/pull/39058
        Aᵖ⁺¹ = A * A
        d = t_norm * sqrt(opnormest1(Aᵖ⁺¹))
        degree_opt = degree_max + 1
        num_mat_mul_opt = typemax(Int)
        for p in 2:p_max # Compute minimum in (3.11)
            Aᵖ⁺¹ *= A
            # (3.7)
            d, d_old = t_norm * opnormest1(Aᵖ⁺¹)^(1//(p + 1)), d
            α = max(d, d_old)
            degree_min = p * (p - 1) - 1
            for degree in degree_min:degree_max
                num_mat_mul = asint(degree * cld(α, θ[degree]))
                if num_mat_mul < num_mat_mul_opt ||
                    (num_mat_mul == num_mat_mul_opt && degree < degree_opt)
                    degree_opt = degree
                    num_mat_mul_opt = num_mat_mul
                end
            end
        end
        scale = max(cld(num_mat_mul_opt, degree_opt), 1)
    end
    return (degree_opt, scale)
end
# work around opnorm(A, 1) and (A^2)*A having very slow defaults for these arrays
# https://github.com/sethaxen/ExponentialAction.jl/issues/3
function _parameters(t, A::Union{Bidiagonal,Tridiagonal}, ncols_B, degree_max, ℓ, tol)
    return _parameters(t, sparse(A), ncols_B, degree_max, ℓ, tol)
end

# avoid differentiating through _parameters with ChainRules-compatible ADs
ChainRulesCore.@non_differentiable _parameters(t, A, ncols_B, degree_max, ℓ, tol)

# solution p to p(p-1) ≤ m + 1
p_from_degree_max(degree_max) = Int(fld(1 + sqrt(5 + 4 * degree_max), 2))

# approximate number of matrix-vector products needed for case 1
_cost_case1(Anorm, n0, m, θm) = Anorm * (n0 * m) / θm

# number of matrix-vector products needed for case 2: estimating all opnorm1 calls
_cost_case2(ℓ, p_max) = 2 * ℓ * p_max * (p_max + 3)

using ExponentialAction, LinearAlgebra, Test

Tdouble = (Float64, ComplexF64)

@testset "expv_sequence" begin
    n = 5
    ts_base = 1:0.1:2
    @testset "expv_sequence(ts, A::$Matrix{$TA}, B::Array{$TB,$(length(Bdims2)+1)}), tscale=$tscale, shift=$shift" for Tset in
                                                                                                                       (
            Tdouble,
        ),
        Bdims2 in ((), (4,)),
        TA in Tset,
        TB in Tset,
        tscale in (0.1, 1, 50),
        shift in (true, false)

        ts = tscale * ts_base
        A = randn(TA, n, n)
        B = randn(TB, n, Bdims2...)
        T = float(Base.promote_eltype(ts, A, B))
        rT = real(T)
        Fs_exp = expv_sequence_explicit(ts, A, B)
        Fs_range = @inferred expv_sequence(ts, A, B; shift)
        @test Fs_range ≈ Fs_exp
        @test eltype(first(Fs_range)) === T
        ts_vec = collect(ts)
        Fs_vec = @inferred expv_sequence(ts_vec, A, B; shift)
        @test Fs_vec ≈ Fs_exp
        @test eltype(first(Fs_vec)) === T
    end

    @testset "length(ts) = 1" begin
        t = rand()
        A = randn(5, 5)
        B = randn(5, 2)
        @test expv_sequence([t], A, B) ≈ [expv(t, A, B)]
        @test expv_sequence(t:1:t, A, B) ≈ [expv(t, A, B)]
    end

    @testset "ts all identical" begin
        A = randn(5, 5)
        B = randn(5, 2)
        Fs = expv_sequence(ones(5), A, B)
        @test all(Fs .≈ Ref(expv(1, A, B)))
        Fs = expv_sequence(zeros(5), A, B)
        @test all(Fs .≈ Ref(B))
    end
end

using ExponentialAction
using FiniteDifferences
using ForwardDiff
using ReverseDiff
using Zygote
using Test
using AbstractDifferentiation: AbstractDifferentiation as AD

function expv_jacobians(ba, t, A, B; f=expv, kwargs...)
    n = size(A, 2)
    tjac = only(AD.jacobian(ba, tvec -> f(tvec[1], A, B; kwargs...), [t]))
    Ajac = only(AD.jacobian(ba, Avec -> f(t, reshape(Avec, n, n), B; kwargs...), vec(A)))
    Bjac = only(AD.jacobian(ba, B -> f(t, A, B; kwargs...), B))
    return tjac, Ajac, Bjac
end

function expv_sequence_jacobians(ba, ts, A, B; f=expv_sequence, kwargs...)
    n = size(A, 2)
    tsjac = only(AD.jacobian(ba, ts -> reduce(vcat, f(ts, A, B; kwargs...)), collect(ts)))
    Ajac = only(
        AD.jacobian(
            ba, Avec -> reduce(vcat, f(ts, reshape(Avec, n, n), B; kwargs...)), vec(A)
        ),
    )
    Bjac = only(AD.jacobian(ba, B -> reduce(vcat, f(ts, A, B; kwargs...)), B))
    return tsjac, Ajac, Bjac
end

function expv_sequence_range_jacobians(ba, ts, A, B; f=expv_sequence, kwargs...)
    n = size(A, 2)
    tmin = ts[begin]
    tmax = ts[end]
    npoints = length(ts)
    tmin_jac = only(
        AD.jacobian(
            ba,
            tmin -> reduce(vcat, f(range(tmin[1], tmax; length=npoints), A, B; kwargs...)),
            [tmin],
        ),
    )
    tmax_jac = only(
        AD.jacobian(
            ba,
            tmax -> reduce(vcat, f(range(tmin, tmax[1]; length=npoints), A, B; kwargs...)),
            [tmax],
        ),
    )
    Ajac = only(
        AD.jacobian(
            ba, Avec -> reduce(vcat, f(ts, reshape(Avec, n, n), B; kwargs...)), vec(A)
        ),
    )
    Bjac = only(AD.jacobian(ba, B -> reduce(vcat, f(ts, A, B; kwargs...)), B))
    return tmin_jac, tmax_jac, Ajac, Bjac
end

@testset "automatic differentiation" begin
    @testset "expv" begin
        t = rand()
        A = randn(10, 10)
        B = randn(10)
        fd_backend = AD.FiniteDifferencesBackend()
        backends = [
            "ForwardDiff" => AD.ForwardDiffBackend(),
            "ReverseDiff" => AD.ReverseDiffBackend(),
            "Zygote" => AD.ZygoteBackend(),
        ]
        tjac_exp, Ajac_exp, Bjac_exp = expv_jacobians(fd_backend, t, A, B; f=expv_explicit)
        @testset "$ba_name" for (ba_name, ba) in backends
            @testset for shift in (true, false)
                tjac, Ajac, Bjac = expv_jacobians(ba, t, A, B; shift)
                @test tjac ≈ tjac_exp atol = 1e-9 rtol = 1e-9
                @test Ajac ≈ Ajac_exp atol = 1e-9 rtol = 1e-9
                @test Bjac ≈ Bjac_exp atol = 1e-9 rtol = 1e-9
            end
        end
    end
    @testset "expv_sequence" begin
        tmin = 10 * rand()
        tmax = tmin + 1
        npoints = 10
        ts = range(tmin, tmax; length=npoints)
        A = randn(5, 5)
        B = randn(5)
        fd_backend = AD.FiniteDifferencesBackend()
        backends = [
            "ForwardDiff" => AD.ForwardDiffBackend(),
            "ReverseDiff" => AD.ReverseDiffBackend(),
            "Zygote" => AD.ZygoteBackend(),
        ]
        @testset "ts::Vector" begin
            tjac_exp, Ajac_exp, Bjac_exp = expv_sequence_jacobians(
                fd_backend, collect(ts), A, B; f=expv_sequence_explicit
            )
            @testset "$ba_name" for (ba_name, ba) in backends
                @testset for shift in (true, false)
                    tjac, Ajac, Bjac = expv_sequence_jacobians(ba, ts, A, B; shift)
                    @test tjac ≈ tjac_exp atol = 1e-9 rtol = 1e-9
                    @test Ajac ≈ Ajac_exp atol = 1e-9 rtol = 1e-9
                    @test Bjac ≈ Bjac_exp atol = 1e-9 rtol = 1e-9
                end
            end
        end
        @testset "ts::StepRangeLen" begin
            tmin_jac_exp, tmax_jac_exp, Ajac_exp, Bjac_exp = expv_sequence_range_jacobians(
                fd_backend, ts, A, B; f=expv_sequence_explicit
            )
            # Zygote currently can't differentiate through StepRangeLen
            # see https://github.com/FluxML/Zygote.jl/issues/550
            @testset "$ba_name" for (ba_name, ba) in
                                    filter(((k, v),) -> k !== "Zygote", backends)
                @testset for shift in (true, false)
                    tmin_jac, tmax_jac, Ajac, Bjac = expv_sequence_range_jacobians(
                        ba, ts, A, B; shift
                    )
                    @test tmin_jac ≈ tmin_jac_exp atol = 1e-9 rtol = 1e-9
                    @test tmax_jac ≈ tmax_jac_exp atol = 1e-9 rtol = 1e-9
                    @test Ajac ≈ Ajac_exp atol = 1e-9 rtol = 1e-9
                    @test Bjac ≈ Bjac_exp atol = 1e-9 rtol = 1e-9
                end
            end
        end
    end
end

# Internals

Documentation for `ExponentialAction.jl`'s internal functions.

See the [Public Documentation](@ref) section for documentation of the public interface.

## Index

```@index
Pages = ["internals.md"]
```

## Internal Interface

```@autodocs
Modules = [ExponentialAction]
Public = false
Private = true
```

```@meta
CurrentModule = ExponentialAction
```

# ExponentialAction

## Introduction

`ExponentialAction.jl` is a lightweight package that implements the action of the [Matrix exponential](https://en.wikipedia.org/wiki/Matrix_exponential) using the algorithm of Al-Mohy and Higham [^AlMohyHigham2011][^Expmv].
For details, see the docstring of [`expv`](@ref).

[^AlMohyHigham2011]: Al-Mohy, Awad H. and Higham, Nicholas J. (2011) Computing the Action of the Matrix Exponential, with an Application to Exponential Integrators.
    SIAM Journal on Scientific Computing, 33 (2). pp. 488-511. ISSN 1064-8275
    doi: [10.1137/100788860](https://doi.org/10.1137/100788860),
    eprint: [eprints.maths.manchester.ac.uk/id/eprint/1591](http://eprints.maths.manchester.ac.uk/id/eprint/1591)
[^Expmv]: [https://github.com/higham/expmv](https://github.com/higham/expmv)

This is the same algorithm used by SciPy's [`expm_multiply`](https://docs.scipy.org/doc/scipy/reference/generated/scipy.sparse.linalg.expm_multiply.html).

While `exp(X)` is only defined in LinearAlgebra for `Diagonal`, `Symmetric{<:Real}`/`Hermitian`, and `StridedMatrix`, `expv` can take an arbitrary matrix type.

## Example

```@repl 1
using LinearAlgebra, ExponentialAction
A = [1.0 2.0; -2.0 3.0];
B = [1.0, 2.0];
exp(A) * B
expv(1, A, B)
exp(2A) * B
expv(2, A, B)
```

## Automatic Differentiation (AD)

Special care has been taken to ensure that `expv` can be differentiated using [`ForwardDiff.jl`](https://github.com/JuliaDiff/ForwardDiff.jl), [`ReverseDiff.jl`](https://github.com/JuliaDiff/ReverseDiff.jl), [`ChainRules.jl`](https://github.com/JuliaDiff/ChainRules.jl/)-compatible packages (e.g. [`Zygote.jl`](https://github.com/FluxML/Zygote.jl)), and likely others as a result.

This has been achieved by avoiding type constraints, not mutating any arrays, and marking operations only used for control flow as being non-differentiable.

## Related Packages

[`ExponentialUtilities.jl`](https://github.com/SciML/ExponentialUtilities.jl) and [`Expokit.jl`](https://github.com/acroy/Expokit.jl) both implement an approximation to the action of the matrix exponential using Krylov subspaces.
Which package is most efficient or useful depends on the choice of matrix and whether derivatives are needed.
If efficiency is important, we recommend choosing from the packages by benchmarking against several of your matrices (if applicable).

!!! note
    The packages use different default tolerances.
    `ExponentialAction.jl` is more strict.
    For a fair comparison, select similar tolerances.

# Public Documentation

Documentation for `ExponentialAction.jl`'s public interface.

See the [Internals](@ref) section for documentation of internal functions.

## Index

```@index
Pages = ["public.md"]
```

## Public Interface

```@autodocs
Modules = [ExponentialAction]
Public = true
Private = false
```
